#include "stdafx.h"
#include "Mop.h"

extern vector<int> Q1,Q2,Q3,Pr,Tr,Tf;
extern int N, num_nodes, old_num_nodes;
extern int num_entr;
extern CBitArray *T1, *T2;
extern CBitArray *X[7];
extern CBitArray *S0[7], *S1[7];
extern CBitArray *R[3];
extern CBitArray *H[4],*G[3];
extern CBitArray *F[7];
extern int bIns;
extern int bExtOut;
extern int bAllXOut;
extern int bQOut;
extern char* FNameMop;
extern ofstream f_out;
vector<int> tmp1,tmp2;
extern int FirstRun2;


void ReadDataFromFile(char *fname)
{
	int i,val;
	char s[100];
	ifstream f_in(fname);
	if (!f_in) exit(0);
	i=0;

	Q1.clear(); Q2.clear(); Q3.clear();
	Tr.clear(); Pr.clear(); tmp1.clear(); tmp2.clear(); Tf.clear();

	while(!f_in.eof() && i<MAXN)
	{
		f_in>>val; if(f_in.eof()) break; 
		           Q1.push_back(val);
		f_in>>val; Q2.push_back(val);
		f_in>>val; Q3.push_back(val);
		f_in>>val; Tr.push_back(val);
		f_in>>val; Pr.push_back(val);
		f_in>>val; tmp1.push_back(val);
		f_in>>val; tmp2.push_back(val);
    Tf.push_back(0);
		i++;
	}
	if (i==MAXN)
	{
		f_in>>val; if(!f_in.eof()) {
			wsprintf(s,"  ..   %d",MAXN);
			AfxMessageBox(s,MB_ICONQUESTION); exit(0);
		}
	}
	N=i;

	num_nodes=0;
	for(i=0;i<N;i++)
	{
		if (Q1[i]>num_nodes) num_nodes=Q1[i];
		if (Q2[i]>num_nodes) num_nodes=Q2[i];
		if (Q3[i]>num_nodes) num_nodes=Q3[i];
	}

	old_num_nodes = num_nodes;
	if (bIns) InsertTrans();
  SortTrans();

	T1= new CBitArray(N);
	T2= new CBitArray(N);

	for(i=0;i<N;i++)
	{
		T1->SetBit(i,tmp1[i]);
		T2->SetBit(i,tmp2[i]);
	}

	if (num_nodes>MAXNUM_NODES)
	{
		wsprintf(s,"  ..   %d",MAXNUM_NODES);
		AfxMessageBox(s,MB_ICONQUESTION); exit(0);
	}

	f_in.close();
}

void WriteQ()
{
	if (!bQOut) return;

	f_out<<"\n\nN= "<<N;
	f_out<<"\nnum_nodes= "<<num_nodes<<"\n\n";

  f_out<<"----------------------------------------\n";
	f_out.width(6);f_out<<"Q1";
	f_out.width(6);f_out<<"Q2";
	f_out.width(6);f_out<<"Q3";
  f_out.width(7);f_out<<"Tr";
	f_out.width(4);f_out<<"Pr";
	f_out.width(3);f_out<<"T1";
	f_out.width(3);f_out<<"T2";
  f_out.width(4);f_out<<" Add\n";
  f_out<<"----------------------------------------\n";
	int siz=Q1.size();
	for(int i=0;i<siz;i++)
	{
		f_out.width(6); f_out<<Q1[i];
		f_out.width(6); f_out<<Q2[i];
		f_out.width(6); f_out<<Q3[i];
		f_out.width(7); f_out<<Tr[i];
		f_out.width(4); f_out<<Pr[i];
		f_out.width(3); f_out<<(int)T1->GetBit(i);
		f_out.width(3); f_out<<(int)T2->GetBit(i);
    if (Tf[i]) {
      f_out.width(4); f_out<<"A";
    }
    f_out<<"\n";
	}
}

void ConvKod2(CBitArray **B, int col, char *s, int f)
{
	int g[3],h[4],i;

	if (f)
	{
		int d=0;	if (f==2) d=3;
		for (i=3;i<7;i++) h[i-3]=B[i-d]->GetBit(col);
		if (h[0] && !h[1] && !h[2] && !h[3]) strcpy(s,"C"); else
		if (!h[0] && h[1] && !h[2] && !h[3]) strcpy(s,"SC"); else
		if (!h[0] && !h[1] && h[2] && !h[3]) strcpy(s,"W"); else 
		if (!h[0] && !h[1] && !h[2] && h[3]) strcpy(s,"D"); else strcpy(s,"?");
		if (f==2) return;
	}
	else strcpy(s,"");

	for (i=0;i<3;i++) g[i]=B[i]->GetBit(col);
	if (g[0] && !g[1] && !g[2]) strcat(s,"0"); else
	if (!g[0] && g[1] && !g[2]) strcat(s,"1"); else
	if (!g[0] && !g[1] && g[2]) strcat(s,"X"); else strcat(s,"?");

	if (f==1 && !h[0] && !h[1] && !h[2] && !h[3] && !g[0] && !g[1] && !g[2])
		strcpy(s," Z");
}

void ConvKod1(char *s, h_type& h, g_type& g)
{
	int nxt=1;
	if (s[0]=='C') h=C; else
	if (s[0]=='W') h=W; else
	if (s[0]=='D') h=D; else {h=SC; nxt=2;}

	if (s[nxt]=='0') g=_0; else
	if (s[nxt]=='1') g=_1; else g=_X;
}

void WriteVars()
{
	char s[5];
	if (bExtOut) f_out<<"---------------------------------------------------------------\n";

	f_out<<"X  : ";
	int lenx = (bAllXOut || !old_num_nodes)? num_nodes : old_num_nodes;
	for(int i=0;i<lenx;i++)
	{
		ConvKod2(X, i, s, 1);
		f_out<<s<<" ";
		if(i==1 || i==num_entr+1) f_out<<" ";
	}
	if (!bExtOut) {f_out<<"\n\n";return;}

	f_out<<"\n\nS0 : ";
	for(i=0;i<N;i++)
	{
		ConvKod2(S0, i, s, 1);
		f_out<<s<<" ";
	}
	f_out<<"\n\nR  : ";
	for(i=0;i<N;i++)
	{
		ConvKod2(R, i, s, 0);
		f_out<<" "<<s<<" ";
	}
	f_out<<"\n\nHG : ";
	for(i=0;i<N;i++)
	{
		char s2[5];
		ConvKod2(H, i, s, 2);
		ConvKod2(G, i, s2, 0);
		f_out<<s<<s2<<" ";
	}
	f_out<<"\n\nF  : ";
	for(i=0;i<N;i++)
	{
		ConvKod2(F, i, s, 1);
		f_out<<s<<" ";
	}
	f_out<<"\n\n\n\n";
}


